window.Gleam.initSearch([{"doc":"ranger","title":"ranger","content":"# ranger\n\n[![Package Version](https://img.shields.io/hexpm/v/ranger)](https://hex.pm/packages/ranger)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/ranger/)\n\nA Gleam project\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add ranger\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/ranger&gt;.\n","url":"index.html"},{"doc":"ranger","title":"Options","content":"pub type Options(item_type, step_type) {\n  Options(\n    validate: fn(item_type) -&gt; Bool,\n    negate_step: fn(step_type) -&gt; step_type,\n    add: fn(item_type, step_type) -&gt; item_type,\n    compare: fn(item_type, item_type) -&gt; order.Order,\n  )\n}\n\nOptions(\n  validate: fn(item_type) -&gt; Bool,\n  negate_step: fn(step_type) -&gt; step_type,\n  add: fn(item_type, step_type) -&gt; item_type,\n  compare: fn(item_type, item_type) -&gt; order.Order,\n)\n\n\nSynonyms:\nranger.Options\nranger Options","url":"ranger.html#Options"},{"doc":"ranger","title":"Range","content":"pub opaque type Range(item_type)\n\n\nSynonyms:\nranger.Range\nranger Range","url":"ranger.html#Range"},{"doc":"ranger","title":"create","content":"pub fn create(options: Options(a, b)) -&gt; fn(a, a, b) -&gt;\n  Result(Range(a), Nil)\n returns a function that can be used to create a range\n\n ## Examples\n\n \n &gt; let options =\n &gt;   Options(\n &gt;     validate: fn(a) { string.length(a) == 1 },\n &gt;     negate_step: fn(s) { -1 * s },\n &gt;     add: fn(a: String, b: Int) {\n &gt;       let [code] = string.to_utf_codepoints(a)\n &gt;       let int_code = string.utf_codepoint_to_int(code)\n &gt;       let new_int_code = int_code + b\n &gt;       let assert Ok(new_code) = string.utf_codepoint(new_int_code)\n &gt;       string.from_utf_codepoints([new_code])\n &gt;     },\n &gt;     compare: string.compare,\n &gt;   )\n &gt; let range = create(options)\n\n &gt; range(&quot;ab&quot;, &quot;e&quot;, 1)\n Error(Nil)\n\n &gt; let assert Ok(a_to_e) = range(&quot;a&quot;, &quot;e&quot;, 1)\n &gt; a_to_e |&gt; unwrap |&gt; iterator.to_list\n [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;]\n \n &gt; let assert Ok(z_to_p) = range(&quot;z&quot;, &quot;p&quot;, 1)\n &gt; z_to_p |&gt; unwrap |&gt; iterator.to_list\n [&quot;z&quot;, &quot;y&quot;, &quot;x&quot;, &quot;w&quot;, &quot;v&quot;, &quot;u&quot;, &quot;t&quot;, &quot;s&quot;, &quot;r&quot;, &quot;q&quot;, &quot;p&quot;]\n\n &gt; let assert Ok(z_to_p) = range(&quot;z&quot;, &quot;p&quot;, -2)\n &gt; z_to_p |&gt; unwrap |&gt; iterator.to_list\n [&quot;z&quot;, &quot;x&quot;, &quot;v&quot;, &quot;t&quot;, &quot;r&quot;, &quot;p&quot;]\n\n &gt; let assert Ok(z_to_p) = range(&quot;z&quot;, &quot;p&quot;, 3)\n &gt; z_to_p |&gt; unwrap |&gt; iterator.to_list\n [&quot;z&quot;, &quot;w&quot;, &quot;t&quot;, &quot;q&quot;]\n \n\n\n \n &gt; let options =\n &gt;   Options(\n &gt;     validate: fn(_) { True },\n &gt;     negate_step: fn(s) { -1.0 *. s },\n &gt;     add: fn(a, b) { a +. b },\n &gt;     compare: float.compare,\n &gt;   )\n &gt; let range = create(options)\n\n &gt; let assert Ok(weird_step_case) = range(1.25, 4.5, -0.5)\n &gt; weird_step_case |&gt; unwrap |&gt; iterator.to_list\n [1.25, 1.75, 2.25, 2.75, 3.25, 3.75, 4.25]\n \n &gt; let assert Ok(single_item_case) = range(1.25, 1.25, -0.25)\n &gt; single_item_case |&gt; unwrap |&gt; iterator.to_list\n [1.25]\n\n &gt; let assert Ok(zero_step_case) = range(2.5, 5.0, 0)\n &gt; zero_step_case |&gt; unwrap |&gt; iterator.to_list\n [2.5]\n \n\nSynonyms:\nranger.create\nranger create","url":"ranger.html#create"},{"doc":"ranger","title":"unwrap","content":"pub fn unwrap(value: Range(a)) -&gt; Iterator(a)\n\nSynonyms:\nranger.unwrap\nranger unwrap","url":"ranger.html#unwrap"},{"doc":"ranger","title":"ranger","content":"","url":"ranger.html"}]);